---
title: PBE_3
layout: layouts/base_subject.njk
eleventyNavigation:
  key: PBE_3
  order: 7
---

<h3 id="react_native">Mobile Applications using React Native</h3>

<p>Make sure to have a decent code editor for writing Javascript available.
  I recommend installing <a href="https://vscodium.com/">VSCodium</a> via your
  operating system's package manager.
</p>

<p>To get started, clone into the
  <a href="https://github.com/senarclens/rn-starter">rn-starter</a> repository.
</p>
{% highlight "bash" %}
git clone git@github.com:senarclens/rn-starter.git
# if you don't have an ssh key in your github profile, use the https url instead
git clone https://github.com/senarclens/rn-starter.git
{% endhighlight %}
<p>Follow the instructions in the repository's
  <a href="https://github.com/senarclens/rn-starter/blob/main/README.md">README.md</a>.
  If you have installed
Android studio and the Android SDK, you can use the Android emulator on
your computer. Otherwise, use the <code>expo</code> app on your mobile
phone.</p>

<p>To get started with react native, follow the interactive
  <a href="https://reactnative.dev/docs/getting-started">react native
    documentation</a>.</p>

<h3 id="docker">Docker</h3>
<p>To pull it all together, we want to
  <ul>
    <li>read live sensor data from our microcontroller</li>
    <li>listen to the sensor data emitted by the microcontroller on a host computer</li>
    <li>store the data in a proper PostgreSQL database</li>
    <li>make this timeseries data graphically available live via a state of the
      art analytics and interactive visualization platform</li>
  </ul>
  The easiest way to set up the top part of our stack is to use Docker to
  locally deploy both PostgreSQL and Grafana.
  The first step is, hence, to download, install and configure
  <a href="https://www.docker.com/">Docker</a> for your platform.<br />
  When this is complete and you user can run docker commands (on Linux systems,
  the user must be in the <code>docker</code> group which is achieved by
  <code>sudo adduser gerald docker</code> and logging in again), perform
  the following actions.
</p>
<ol>
  <li>Run Grafana in a new container. The grafana container is automatically
    downloaded. The new container will be available by the name
    (<code>--name grafana</code>), will expose its port 3000 on the host
    computer (<code>-p 3000:3000</code>) and run in background
    (<code>--detach</code>).<br />
    <code>docker run --name=grafana -p 3000:3000
                     --detach grafana/grafana</code></li>
  <li>Run PostgreSQL in a new container. The container will receive the
    PostgresSQL password via an environment variable
    (<code>--env POSTGRES_PASSWORD=super-secret</code>)<br />
    <code>docker run --name docker-postgres --env POSTGRES_PASSWORD=super-secret
                     -p 5432:5432 -d postgres</code></li>
  <li>Create a new network so that the containers can communicate with each
    other. Add both containers to the same network.<br />
{% highlight "bash" %}
docker network create grafana-net
docker network connect grafana-net docker-postgres
docker network connect grafana-net grafana
{% endhighlight %}
  </li>
  <li>Read the ip address of the PostgreSQL container and use this IP for
    setting up the PostgreSQL data source in grafana.<br />
    <code>docker network inspect grafana-net</code></li>
  <li>Connect to <a href="http://localhost:3000">localhost:3000</a>, log in
    via user <kbd>admin</kbd> and password <kbd>admin</kbd> (or the values
    you picked) and set up Grafana to your needs. When adding PostgreSQL
    as data source, disable SSL for this setup.</li>
  <li>If you want to start your containers after rebooting the host, do so by
    referencing their names in the <code>docker container start</code>
    command.<br />
    <code>docker container start docker-postgres</code><br />
    <code>docker container start grafana</code>
  </li>
</ol>

<h3>Source Code</h3>
<p>The source code created for or in this class is available at
  <a href="https://gitlab.com/senarclens/micropython-examples/">
    https://gitlab.com/senarclens/micropython-examples/</a> or via<br />
<code>git clone git@gitlab.com:senarclens/micropython-examples.git</code></p>


<h3>Links</h3>
<ul>
  <li><a href="http://docs.find-santa.eu/dvcs/">Git commands</a></li>
  <li><a href="https://www.senarclens.eu/~gerald/presentations/cms1/4_functions/">Python Syntax: Functions</a></li>
  <li><a href="https://wokwi.com/arduino/new?template=micropython-pi-pico">Wokwi RP Pico simulator</a></li>
  <li><a href="https://training.play-with-docker.com/">Docker Classroom</a></li>
</ul>

<div><strong>Lehrstoff</strong></div>
<ul>
  <li>Bereich Hardwareentwicklung
    <ul>
      <li>Werkstättenlaboratorium „Consumer-Electronics“ (Aufbau, Inbetriebnahme, Prüfung und Reparatur von Geräten der Consumer-Electronics, Sende- und Empfangsanlagen)</li>
    </ul>
  </li>
  <li>Bereich Messtechnik und Regelungssysteme:
    <ul>
      <li>Werkstättenlaboratorium „Messtechnik 2“ (Auswahl und Anwendung geeigneter Messgeräte; systematische Fehlersuche)</li>
      <li>Werkstättenlaboratorium „Steuerungs- und Regelungstechnik“ (Aufbau und Inbetriebnahme von Sensoren/Aktoren an programmierbaren Steuerungen und Bussystemen; Aufbau und Inbetriebnahme von Regelungssystemen; Programmierung von Prozessleitsystemen).</li>
    </ul>
  </li>
  <li>Bereich Digitale Systeme und Computersysteme
    <ul>
      <li>Werkstättenlaboratorium „Digitaltechnik 2“ (testen von Algorithmen und Fehlersuche in Algorithmen für Mikrocontroller sowie programmierbaren Logikbausteinen)</li>
    </ul>
  </li>
  <li>Bereich Kommunikationssysteme und -netze
    <ul>
      <li>Werkstättenlaboratorium „Netzwerkinstallation 2“ (Netzwerkkomponenten)</li>
      <li>Werkstättenlaboratorium „Kommunikationssysteme 2“ (Aufbau, Konfiguration von und Messungen an mobilen Kommunikationseinrichtungen)</li>
    </ul>
  </li>
</ul>
